A Top-level Domain for Private Use
Kim Davies
Internet Assigned Numbers Authority
kim.davies@iana.org
Andrew McConachie
Internet Corporation for Assigned Names and Numbers
andrew.mcconachie@icann.org
18 October 2024
Internet-Draft
This document describes the "internal" top-level domain for use in private applications.
Introduction
There are certain circumstances where private network operators may wish to use their own domain naming scheme that is not intended to be used or accessible by the global domain name system (DNS), such as within closed corporate or home networks.
The "internal" top-level domain provides this purpose in the DNS. Such domains will not resolve in the global DNS, but can be configured within closed networks as the network operator sees fit. It fulfils a similar purpose as private-use IP address ranges that are set aside (e.g. [RFC1918]).
Terminology
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in [BCP14] when, and only when, they appear in all capitals, as shown here.
This document assumes familiarity with DNS terms; please see [BCP219].
Using the ".internal" Namespace
Network operators have been using different names for private-use DNS for many years. This usage has been uncoordinated and can result in incompatibilities or harm to Internet users. For example, an organization might choose to use a name for this purpose that has not been assigned to them, that would later appear in the global DNS thereby causing name collisions and undefined behavior for users.
If an organization determines that they require a private-use DNS namespace, they should either use sub-domains of a global DNS name that is under their organizational and operational control, or use the "internal" top-level domain. This document does not offer guidance on when a network operators should choose the "internal" top-level domain instead of a sub-domain of a global DNS name. This decision will depend on multiple factors such as network design or organizational needs, and is outside the scope of this publication.
Comparisons to Similar Namespaces
Other namespaces are reserved for similar purposes, which superficially may seem to serve the same purpose as the "internal" domain, but are intended for different use cases.
- The "local" namespace [RFC6762] is reserved for use with the multicast DNS protocol. This protocol allows for resolution between devices on a local network. This namespace does not use typical DNS zones for name allocation, and instead uses the multicast DNS protocol to negotiate names and resolve conflicts. It is expected "internal" will be used for applications where names are specified in locally-configured zones.
- The "alt" namespace [RFC9476] is reserved for contexts where identifiers are used that may look like domain names, but do not use the DNS protocol for resolution. This is in contrast to the "internal" domain which is to be used with the DNS protocol, but in limited private-use network scope.
- The "home.arpa" namespace [RFC8375] is reserved for use within residential networks, including the Home Networking Control Protocol [RFC7788].
IANA Considerations
The document requires no IANA actions. For the reasons stated above, as the "internal" top-level domain is reserved from being used in the global DNS it MUST NOT appear in the DNS root zone.
Security Considerations
While the namespace is designated for private use, there is no guarantee that the names utilized in this namespace will not leak into the broader Internet. Since usage may appear in log files, email headers, and the like; users should not rely on the confidentiality of the "internal" namespace.
Users should also not assume the appearance of such names is indicative of the true source of transmissions. When diagnosing network issues, the appearance of such addresses must be interpreted with the associated context to ascertain the private network with which the name is being used. A private-use name can never be used by itself to identify the origin of a communication. It is entirely likely that many of the same names will be used for entirely different purposes on different networks connected to the Internet.
Additional Information
This reservation is the result of a community deliberation on this topic over many years, most notably [SAC113]. The SAC113 advisory recommended the establishment of a single top-level domain for private-use applications. This top-level domain would not be delegated in the DNS root zone to ensure it is not resolvable in contexts outside of a private network.
A selection process [IANA-Assessment] determined "internal" was the best suited string given the requirement that a single string be selected for this purpose, and subsequently reserved for this purpose in July 2024. [ICANN-Board-Resolution]

Informative References
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
[RFC9499]

DNS Terminology
P. Hoffman
K. Fujiwara
March 2024
BCP 219
RFC 9499
DOI 10.17487/RFC9499
[RFC1918]

Address Allocation for Private Internets
Y. Rekhter
B. Moskowitz
D. Karrenberg
G. J. de Groot
E. Lear
February 1996
BCP 5
RFC 1918
DOI 10.17487/RFC1918
[RFC6762]

Multicast DNS
S. Cheshire
M. Krochmal
February 2013
RFC 6762
DOI 10.17487/RFC6762
[RFC7788]

Home Networking Control Protocol
M. Stenberg
S. Barth
P. Pfister
April 2016
RFC 7788
DOI 10.17487/RFC7788
[RFC8375]

Special-Use Domain 'home.arpa.'
P. Pfister
T. Lemon
May 2018
RFC 8375
DOI 10.17487/RFC8375
[RFC9476]

The .alt Special-Use Top-Level Domain
W. Kumari
P. Hoffman
September 2023
RFC 9476
DOI 10.17487/RFC9476
[SAC113]

SSAC Advisory on Private-Use TLDs
September 2020
[IANA-Assessment]

Identification of a top-level domain for private use
January 2024
[ICANN-Board-Resolution]

Reserving .INTERNAL for Private-Use Applications
July 2024
Notes (for removal before publication)
- It is currently assumed this domain should NOT be designated as a special-use domain name at https://www.iana.org/assignments/special-use-domain-names/.
- I-D source is maintained at: https://github.com/kjd/draft-davies-internal-tld